import { Chain } from "../chains";
export type TokenKey = string;
export type TokenSymbol = string;
export type ChainTokens = {
    [symbol: TokenKey]: Token;
};
export type Token = {
    key: TokenKey;
    decimals: number;
    address: string | "native";
    chain: Chain;
    symbol: TokenSymbol;
    original?: Chain;
    wrapped?: {
        symbol: string;
        decimals: number;
    };
};
export type TokenConst = Omit<Token, "chain" | "key">;
export type TokenDetails = {
    key: string;
    symbol: TokenSymbol;
    nativeChain: Chain;
    coinGeckoId: string;
    displayName?: string;
};
//# sourceMappingURL=types.d.ts.map